package com.example.rpserver.controller;

import com.example.rpserver.model.Credential;
import com.example.rpserver.model.Response;
import com.example.rpserver.repository.CredentialRepository;
import com.webauthn4j.data.PublicKeyCredentialDescriptor;
import com.webauthn4j.data.PublicKeyCredentialRequestOptions;
import com.webauthn4j.data.PublicKeyCredentialType;
import com.webauthn4j.data.client.challenge.Challenge;
import com.webauthn4j.data.client.challenge.DefaultChallenge;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import java.util.LinkedList;
import java.util.List;

@RestController
public class GetAssertion {
	private static Logger logger = LoggerFactory.getLogger(GetAssertion.class);
	@Autowired
	private CredentialRepository credentialRepository;
	@ResponseBody
	@PostMapping("/BeginGetAssertion")
	public ResponseEntity<PublicKeyCredentialRequestOptions> beginGetAssertion(@RequestParam("username") String username){
		Challenge challenge = new DefaultChallenge();
		List<Credential> credentials = credentialRepository.getCredentialsByUserName(username);
		LinkedList<PublicKeyCredentialDescriptor> publicKeyCredentialDescriptors = new LinkedList<>();
		for(Credential credential : credentials){
			PublicKeyCredentialDescriptor publicKeyCredentialDescriptor = new PublicKeyCredentialDescriptor(PublicKeyCredentialType.PUBLIC_KEY, credential.getRawId(), null);
			publicKeyCredentialDescriptors.add(publicKeyCredentialDescriptor);
		}
		PublicKeyCredentialRequestOptions options = new PublicKeyCredentialRequestOptions(challenge, null, "localhost", publicKeyCredentialDescriptors, null, null);
		return ResponseEntity.ok(options);
	}
	@ResponseBody
	@PostMapping("/FinishGetAssertion")
	public ResponseEntity<Response> finishMakeCredential(@RequestParam("data") String data){
		logger.info("data : {}", data);
		logger.info("Finish Get Assertion");
		return ResponseEntity.ok(new Response(true, "Login Successfully"));
	}
}
